import { provide, reactive } from 'vue';
import { useContext } from '../hooks/context';
export var defaultPrefixCls = 'ant-pro';
export var getPrefixCls = function getPrefixCls(suffixCls, customizePrefixCls) {
  if (customizePrefixCls) return customizePrefixCls;
  return suffixCls ? "".concat(defaultPrefixCls, "-").concat(suffixCls) : defaultPrefixCls;
};
export var defaultRouteContext = reactive({
  getPrefixCls: getPrefixCls,
  locale: function locale(t) {
    return t;
  },
  contentWidth: 'Fluid',
  hasFooterToolbar: false
});
export var routeContextInjectKey = Symbol('jetlinks-route-context');
export var provideRouteContext = function provideRouteContext(value) {
  provide(routeContextInjectKey, value);
};
export var useRouteContext = function useRouteContext() {
  return useContext(routeContextInjectKey, defaultRouteContext);
};