import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
export function clearMenuItem(menusData) {
  return menusData.map(function (item) {
    var _finalItem$meta;
    var finalItem = _objectSpread({}, item);
    if ((_finalItem$meta = finalItem.meta) !== null && _finalItem$meta !== void 0 && _finalItem$meta.hideInMenu) {
      return null;
    }
    if (finalItem && finalItem !== null && finalItem !== void 0 && finalItem.children) {
      var _finalItem$meta2;
      if (!((_finalItem$meta2 = finalItem.meta) !== null && _finalItem$meta2 !== void 0 && _finalItem$meta2.hideChildInMenu) && finalItem.children.some(function (child) {
        var _child$meta;
        return child && child.name && !((_child$meta = child.meta) !== null && _child$meta !== void 0 && _child$meta.hideInMenu);
      })) {
        return _objectSpread(_objectSpread({}, item), {}, {
          children: clearMenuItem(finalItem.children)
        });
      }
      delete finalItem.children;
    }
    return finalItem;
  }).filter(function (item) {
    return item;
  });
}
export function flatMap(menusData) {
  return menusData.map(function (item) {
    var _finalItem$meta3;
    var finalItem = _objectSpread({}, item);
    if (!finalItem.name || (_finalItem$meta3 = finalItem.meta) !== null && _finalItem$meta3 !== void 0 && _finalItem$meta3.hideInMenu) {
      return null;
    }
    if (finalItem.children) {
      delete finalItem.children;
    }
    return finalItem;
  }).filter(function (item) {
    return item;
  });
}
export function getMenuFirstChildren(menus, key) {
  return key === undefined ? [] : (menus[menus.findIndex(function (menu) {
    return menu.path === key;
  })] || {}).children || [];
}
export function getSlot(slots, props) {
  var prop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'default';
  if (props[prop] === false) {
    // force not render
    return false;
  }
  return props[prop] || slots[prop];
}
export function getSlotVNode(slots, props) {
  var _slots$prop;
  var prop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'default';
  if (props[prop] === false) {
    return false;
  }
  return props[prop] || ((_slots$prop = slots[prop]) === null || _slots$prop === void 0 ? void 0 : _slots$prop.call(slots));
}