import _createClass from "@babel/runtime/helpers/esm/createClass";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import _wrapNativeSuper from "@babel/runtime/helpers/esm/wrapNativeSuper";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
export { isBoolean, isNumber } from '@vueuse/core';
import { isNumber } from '@vueuse/core';
// import {process} from '@types/node'
import { isString } from '@vue/shared';
export { isArray, isFunction, isObject, isString, isDate, isPromise, isSymbol } from '@vue/shared';
export var keysOf = function keysOf(arr) {
  return Object.keys(arr);
};
export var entriesOf = function entriesOf(arr) {
  return Object.entries(arr);
};
export { hasOwn } from '@vue/shared';
export var GAP = 4; // top 2 + bottom 2 of bar instance
export var BAR_MAP = {
  vertical: {
    offset: 'offsetHeight',
    scroll: 'scrollTop',
    scrollSize: 'scrollHeight',
    size: 'height',
    key: 'vertical',
    axis: 'Y',
    client: 'clientY',
    direction: 'top'
  },
  horizontal: {
    offset: 'offsetWidth',
    scroll: 'scrollLeft',
    scrollSize: 'scrollWidth',
    size: 'width',
    key: 'horizontal',
    axis: 'X',
    client: 'clientX',
    direction: 'left'
  }
};
export var renderThumbStyle = function renderThumbStyle(_ref) {
  var _ref2;
  var move = _ref.move,
    size = _ref.size,
    bar = _ref.bar;
  return _ref2 = {}, _defineProperty(_ref2, bar.size, size), _defineProperty(_ref2, "transform", "translate".concat(bar.axis, "(").concat(move, "%)")), _ref2;
};
var ElementPlusError = /*#__PURE__*/function (_Error) {
  _inherits(ElementPlusError, _Error);
  var _super = _createSuper(ElementPlusError);
  function ElementPlusError(m) {
    var _this;
    _classCallCheck(this, ElementPlusError);
    _this = _super.call(this, m);
    _this.name = 'ElementPlusError';
    return _this;
  }
  return _createClass(ElementPlusError);
}( /*#__PURE__*/_wrapNativeSuper(Error));
export function throwError(scope, m) {
  throw new ElementPlusError("[".concat(scope, "] ").concat(m));
}
export function debugWarn(scope, message) {
  if (process.env.NODE_ENV !== 'production') {
    var error = isString(scope) ? new ElementPlusError("[".concat(scope, "] ").concat(message)) : scope;
    // eslint-disable-next-line no-console
    console.warn(error);
  }
}
export var definePropType = function definePropType(val) {
  return val;
};
export var isStringNumber = function isStringNumber(val) {
  if (!isString(val)) {
    return false;
  }
  return !Number.isNaN(Number(val));
};
var SCOPE = 'utils/dom/style';
export function addUnit(value) {
  var defaultUnit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'px';
  if (!value) return '';
  if (isNumber(value) || isStringNumber(value)) {
    return "".concat(value).concat(defaultUnit);
  } else if (isString(value)) {
    return value;
  }
  debugWarn(SCOPE, 'binding value must be a string or number');
}