function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) {
    const op = ops[i];
    const fn = ops[i + 1];
    i += 2;
    if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) {
        return undefined;
    }
    if (op === 'access' || op === 'optionalAccess') {
        lastAccessLHS = value;
        value = fn(value);
    }
    else if (op === 'call' || op === 'optionalCall') {
        value = fn((...args) => value.call(lastAccessLHS, ...args));
        lastAccessLHS = undefined;
    }
} return value; }
/* Analyzed bindings: {
  "value": "props",
  "placement": "props",
  "UnitSelect": "setup-maybe-ref",
  "UnitProps": "setup-maybe-ref",
  "inject": "setup-const",
  "reactive": "setup-const",
  "ref": "setup-const",
  "Form": "setup-maybe-ref",
  "FormItem": "setup-maybe-ref",
  "PopconfirmModal": "setup-maybe-ref",
  "Icon": "setup-const",
  "FULL_CODE": "setup-maybe-ref",
  "emit": "setup-const",
  "props": "setup-reactive-const",
  "formRef": "setup-ref",
  "formData": "setup-reactive-const",
  "fullRef": "setup-maybe-ref",
  "confirm": "setup-const",
  "cancel": "setup-const"
} */
import { defineComponent as _defineComponent } from 'vue';
import { unref as _unref, createVNode as _createVNode, withCtx as _withCtx, renderSlot as _renderSlot, openBlock as _openBlock, createBlock as _createBlock } from "vue";
import UnitSelect, { UnitProps } from '../UnitSelect';
import { inject, reactive, ref } from 'vue';
import { Form, FormItem, PopconfirmModal } from '../../../components';
import Icon from '../Icon.js';
import { FULL_CODE } from '../../index';
const __sfc_main__ = /*#__PURE__*/ _defineComponent({
    props: {
        ...UnitProps,
        value: {
            type: String,
            default: undefined,
        },
        placement: {
            type: String,
            default: 'top',
        },
    },
    emits: ['update:value', 'confirm', 'cancel'],
    setup(__props, { emit }) {
        const props = __props;
        const formRef = ref();
        const formData = reactive({
            unit: props.value,
        });
        const fullRef = inject(FULL_CODE);
        const confirm = () => {
            return new Promise(async (resolve, reject) => {
                formRef.value
                    .validate()
                    .then(() => {
                    resolve(true);
                    emit('update:value', formData.unit);
                    emit('confirm', formData.unit);
                })
                    .catch((e) => {
                    reject(false);
                });
            });
        };
        const cancel = () => {
            _optionalChain([formRef, 'access', _2 => _2.value, 'optionalAccess', _3 => _3.resetFields, 'call', _4 => _4()]);
            formData.unit = props.value;
            emit('cancel');
        };
        return (_ctx, _cache) => {
            return (_openBlock(), _createBlock(_unref(PopconfirmModal), {
                "body-style": "padding-top:4px; width: 260px;",
                placement: __props.placement,
                "get-popup-container": (node) => _unref(fullRef) || _ctx.document.body,
                onConfirm: confirm,
                onCancel: cancel
            }, {
                content: _withCtx(() => [
                    _createVNode(_unref(Form), {
                        ref_key: "formRef",
                        ref: formRef,
                        model: formData,
                        layout: "vertical"
                    }, {
                        default: _withCtx(() => [
                            _createVNode(_unref(FormItem), {
                                label: "单位",
                                name: "unit",
                                rules: [{ max: 64, message: '最多可输入64个字符' }]
                            }, {
                                default: _withCtx(() => [
                                    _createVNode(_unref(UnitSelect), {
                                        value: formData.unit,
                                        "onUpdate:value": _cache[0] || (_cache[0] = ($event) => ((formData.unit) = $event)),
                                        options: _ctx.options
                                    }, null, 8 /* PROPS */, ["value", "options"])
                                ]),
                                _: 1 /* STABLE */
                            })
                        ]),
                        _: 1 /* STABLE */
                    }, 8 /* PROPS */, ["model"])
                ]),
                default: _withCtx(() => [
                    _renderSlot(_ctx.$slots, "default", {}, () => [
                        _createVNode(Icon)
                    ])
                ]),
                _: 3 /* FORWARDED */
            }, 8 /* PROPS */, ["placement", "get-popup-container"]));
        };
    }
});
export default __sfc_main__;