function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) {
    const op = ops[i];
    const fn = ops[i + 1];
    i += 2;
    if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) {
        return undefined;
    }
    if (op === 'access' || op === 'optionalAccess') {
        lastAccessLHS = value;
        value = fn(value);
    }
    else if (op === 'call' || op === 'optionalCall') {
        value = fn((...args) => value.call(lastAccessLHS, ...args));
        lastAccessLHS = undefined;
    }
} return value; }
/* Analyzed bindings: {
  "modelValue": "props",
  "theme": "props",
  "language": "props",
  "codeTips": "props",
  "init": "props",
  "registrationTips": "props",
  "registrationTypescript": "props",
  "blurFormat": "props",
  "ref": "setup-const",
  "onMounted": "setup-const",
  "watch": "setup-const",
  "onUnmounted": "setup-const",
  "toRaw": "setup-const",
  "nextTick": "setup-const",
  "monaco": "setup-const",
  "props": "setup-reactive-const",
  "emit": "setup-const",
  "dom": "setup-ref",
  "instance": "setup-ref",
  "monacoProviderRef": "setup-ref",
  "monacoTypescriptProviderRef": "setup-ref",
  "handleSuggestions": "setup-const",
  "disposeRegister": "setup-const",
  "registerCompletionItemProvider": "setup-const",
  "disposeTypescript": "setup-const",
  "registerTypescript": "setup-const",
  "editorFormat": "setup-const",
  "insert": "setup-const"
} */
import { openBlock as _openBlock, createElementBlock as _createElementBlock } from "vue";
import { ref, onMounted, watch, onUnmounted, toRaw, nextTick, } from 'vue';
import * as monaco from 'monaco-editor';
const __sfc_main__ = {
    props: {
        modelValue: [String, Number],
        theme: { type: String, default: 'vs-dark' },
        language: { type: String, default: 'json' },
        codeTips: { type: Array, default: () => [] },
        init: { type: Function, default: undefined },
        registrationTips: { type: Object, default: () => ({}) },
        registrationTypescript: { type: Object, default: () => ({}) },
        blurFormat: { type: Boolean, default: true },
    },
    emits: [
        'update:modelValue',
        'blur',
        'focus',
        'change',
        'errorChange',
    ],
    setup(__props, { expose, emit }) {
        const props = __props;
        const dom = ref();
        const instance = ref();
        const monacoProviderRef = ref();
        const monacoTypescriptProviderRef = ref();
        // codeTipItem.dispose() // 销毁自定义提示
        const handleSuggestions = (suggestions, range) => {
            return Array.isArray(suggestions)
                ? suggestions.map((item) => ({ ...item, range }))
                : [];
        };
        const disposeRegister = () => {
            _optionalChain([monacoProviderRef, 'access', _ => _.value, 'optionalAccess', _2 => _2.dispose, 'call', _3 => _3()]);
            monacoProviderRef.value = null;
        };
        /**
         * 代码提示注册
         */
        const registerCompletionItemProvider = () => {
            disposeRegister();
            if (monaco.languages && _optionalChain([props, 'access', _4 => _4.registrationTips, 'optionalAccess', _5 => _5.suggestions])) {
                const { name, suggestions } = props.registrationTips;
                monacoProviderRef.value =
                    monaco.languages.registerCompletionItemProvider(name || 'json', {
                        provideCompletionItems: function (model, position) {
                            const word = model.getWordUntilPosition(position); // 获取提示代码范围位置
                            const range = {
                                startLineNumber: position.lineNumber,
                                endLineNumber: position.lineNumber,
                                startColumn: word.startColumn,
                                endColumn: word.endColumn,
                            };
                            return {
                                suggestions: handleSuggestions(suggestions, range),
                            };
                        },
                    });
            }
        };
        const disposeTypescript = () => {
            _optionalChain([monacoTypescriptProviderRef, 'access', _6 => _6.value, 'optionalAccess', _7 => _7.dispose, 'call', _8 => _8()]);
            monacoTypescriptProviderRef.value = null;
        };
        const registerTypescript = () => {
            disposeTypescript();
            if (monaco.languages && _optionalChain([props, 'access', _9 => _9.registrationTypescript, 'optionalAccess', _10 => _10.typescript])) {
                const { name, typescript } = props.registrationTypescript;
                monacoTypescriptProviderRef.value =
                    monaco.languages.typescript.javascriptDefaults.addExtraLib(typescript);
            }
        };
        /**
         * 代码格式化
         */
        const editorFormat = () => {
            if (!instance.value)
                return;
            _optionalChain([toRaw, 'call', _11 => _11(instance.value), 'access', _12 => _12.getAction, 'call', _13 => _13('editor.action.formatDocument'), 'optionalAccess', _14 => _14.run, 'call', _15 => _15()]);
        };
        monaco.editor.onDidChangeMarkers(([uri]) => {
            const markers = monaco.editor.getModelMarkers({ resource: uri });
            emit('errorChange', markers);
        });
        onMounted(async () => {
            const _model = monaco.editor.createModel(props.modelValue, props.language);
            instance.value = monaco.editor.create(dom.value, {
                model: _model,
                tabSize: 2,
                automaticLayout: true,
                scrollBeyondLastLine: false,
                theme: props.theme,
                formatOnPaste: true,
            });
            instance.value.onDidChangeModelContent(() => {
                //
                const value = toRaw(instance.value).getValue();
                nextTick(() => {
                    emit('update:modelValue', value);
                    emit('change', value);
                });
            });
            instance.value.onDidBlurEditorText(() => {
                emit('blur');
                if (props.blurFormat) {
                    editorFormat();
                }
            });
            instance.value.onDidFocusEditorText(() => {
                emit('focus');
            });
            if (props.modelValue) {
                setTimeout(() => {
                    editorFormat();
                }, 200);
            }
            _optionalChain([props, 'access', _16 => _16.init, 'optionalCall', _17 => _17(instance.value, monaco)]);
        });
        /**
         * 光标位置插入内容
         * @param {String} val
         */
        const insert = (val) => {
            if (!instance.value)
                return;
            const position = toRaw(instance.value).getPosition();
            const value = toRaw(instance.value).getValue();
            toRaw(instance.value).executeEdits(value, [
                {
                    range: new monaco.Range(_optionalChain([position, 'optionalAccess', _18 => _18.lineNumber]), _optionalChain([position, 'optionalAccess', _19 => _19.column]), _optionalChain([position, 'optionalAccess', _20 => _20.lineNumber]), _optionalChain([position, 'optionalAccess', _21 => _21.column])),
                    text: val,
                },
            ]);
        };
        watch(() => props.modelValue, (val) => {
            if (!instance.value ||
                (instance.value &&
                    props.modelValue === toRaw(instance.value).getValue()))
                return;
            // setValue之前获取光标位置
            const position = toRaw(instance.value).getPosition();
            // setValue之后光标位置改变
            toRaw(instance.value).setValue(val);
            // 设置光标位置为setValue之前的位置
            toRaw(instance.value).setPosition(position);
            editorFormat();
        });
        watch(() => JSON.stringify(props.registrationTips), () => {
            registerCompletionItemProvider();
        }, { immediate: true });
        watch(() => JSON.stringify(props.registrationTypescript), () => {
            registerTypescript();
        }, { immediate: true });
        onUnmounted(() => {
            disposeRegister();
            disposeTypescript();
            _optionalChain([toRaw, 'call', _22 => _22(instance.value), 'access', _23 => _23.editor, 'optionalAccess', _24 => _24.dispose, 'optionalCall', _25 => _25()]);
        });
        expose({
            editorFormat,
            insert,
        });
        return (_ctx, _cache) => {
            return (_openBlock(), _createElementBlock("div", {
                ref_key: "dom",
                ref: dom,
                class: "j-monaco-editor"
            }, null, 512 /* NEED_PATCH */));
        };
    }
};
export default __sfc_main__;