"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRouteContext = exports.routeContextInjectKey = exports.provideRouteContext = exports.getPrefixCls = exports.defaultRouteContext = exports.defaultPrefixCls = void 0;
var _vue = require("vue");
var _context = require("../hooks/context");
var defaultPrefixCls = 'ant-pro';
exports.defaultPrefixCls = defaultPrefixCls;
var getPrefixCls = function getPrefixCls(suffixCls, customizePrefixCls) {
  if (customizePrefixCls) return customizePrefixCls;
  return suffixCls ? "".concat(defaultPrefixCls, "-").concat(suffixCls) : defaultPrefixCls;
};
exports.getPrefixCls = getPrefixCls;
var defaultRouteContext = (0, _vue.reactive)({
  getPrefixCls: getPrefixCls,
  locale: function locale(t) {
    return t;
  },
  contentWidth: 'Fluid',
  hasFooterToolbar: false
});
exports.defaultRouteContext = defaultRouteContext;
var routeContextInjectKey = Symbol('jetlinks-route-context');
exports.routeContextInjectKey = routeContextInjectKey;
var provideRouteContext = function provideRouteContext(value) {
  (0, _vue.provide)(routeContextInjectKey, value);
};
exports.provideRouteContext = provideRouteContext;
var useRouteContext = function useRouteContext() {
  return (0, _context.useContext)(routeContextInjectKey, defaultRouteContext);
};
exports.useRouteContext = useRouteContext;