"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultSettings = exports.defaultSettingProps = void 0;
var defaultSettings = {
  theme: 'light',
  layout: 'mix',
  contentWidth: 'Fluid',
  fixedHeader: true,
  fixSiderbar: true,
  menu: {
    locale: true
  },
  headerHeight: 48,
  title: 'Jetlink UI Components',
  iconfontUrl: '',
  primaryColor: '#315EFB'
};
exports.defaultSettings = defaultSettings;
var defaultSettingProps = {
  theme: {
    type: String,
    default: defaultSettings.theme
  },
  layout: {
    type: String,
    default: defaultSettings.layout
  },
  contentWidth: {
    type: String,
    default: defaultSettings.contentWidth
  },
  fixedHeader: {
    type: Boolean,
    default: defaultSettings.fixedHeader
  },
  fixSiderbar: {
    type: Boolean,
    default: defaultSettings.fixSiderbar
  },
  menu: {
    type: Object,
    default: function _default() {
      return {
        locale: true
      };
    }
  },
  headerHeight: {
    type: Number,
    default: defaultSettings.headerHeight
  },
  title: {
    type: String,
    default: function _default() {
      return defaultSettings.title;
    }
  },
  iconfontUrl: {
    type: String,
    default: function _default() {
      return defaultSettings.iconfontUrl;
    }
  },
  primaryColor: {
    type: String,
    default: function _default() {
      return defaultSettings.primaryColor;
    }
  }
};
exports.defaultSettingProps = defaultSettingProps;