"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GAP = exports.BAR_MAP = void 0;
exports.addUnit = addUnit;
exports.debugWarn = debugWarn;
exports.entriesOf = exports.definePropType = void 0;
Object.defineProperty(exports, "hasOwn", {
  enumerable: true,
  get: function get() {
    return _shared.hasOwn;
  }
});
Object.defineProperty(exports, "isArray", {
  enumerable: true,
  get: function get() {
    return _shared.isArray;
  }
});
Object.defineProperty(exports, "isBoolean", {
  enumerable: true,
  get: function get() {
    return _core.isBoolean;
  }
});
Object.defineProperty(exports, "isDate", {
  enumerable: true,
  get: function get() {
    return _shared.isDate;
  }
});
Object.defineProperty(exports, "isFunction", {
  enumerable: true,
  get: function get() {
    return _shared.isFunction;
  }
});
Object.defineProperty(exports, "isNumber", {
  enumerable: true,
  get: function get() {
    return _core.isNumber;
  }
});
Object.defineProperty(exports, "isObject", {
  enumerable: true,
  get: function get() {
    return _shared.isObject;
  }
});
Object.defineProperty(exports, "isPromise", {
  enumerable: true,
  get: function get() {
    return _shared.isPromise;
  }
});
Object.defineProperty(exports, "isString", {
  enumerable: true,
  get: function get() {
    return _shared.isString;
  }
});
exports.isStringNumber = void 0;
Object.defineProperty(exports, "isSymbol", {
  enumerable: true,
  get: function get() {
    return _shared.isSymbol;
  }
});
exports.renderThumbStyle = exports.keysOf = void 0;
exports.throwError = throwError;
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _core = require("@vueuse/core");
var _shared = require("@vue/shared");
// import {process} from '@types/node'

var keysOf = function keysOf(arr) {
  return Object.keys(arr);
};
exports.keysOf = keysOf;
var entriesOf = function entriesOf(arr) {
  return Object.entries(arr);
};
exports.entriesOf = entriesOf;
var GAP = 4; // top 2 + bottom 2 of bar instance
exports.GAP = GAP;
var BAR_MAP = {
  vertical: {
    offset: 'offsetHeight',
    scroll: 'scrollTop',
    scrollSize: 'scrollHeight',
    size: 'height',
    key: 'vertical',
    axis: 'Y',
    client: 'clientY',
    direction: 'top'
  },
  horizontal: {
    offset: 'offsetWidth',
    scroll: 'scrollLeft',
    scrollSize: 'scrollWidth',
    size: 'width',
    key: 'horizontal',
    axis: 'X',
    client: 'clientX',
    direction: 'left'
  }
};
exports.BAR_MAP = BAR_MAP;
var renderThumbStyle = function renderThumbStyle(_ref) {
  var _ref2;
  var move = _ref.move,
    size = _ref.size,
    bar = _ref.bar;
  return _ref2 = {}, (0, _defineProperty2.default)(_ref2, bar.size, size), (0, _defineProperty2.default)(_ref2, "transform", "translate".concat(bar.axis, "(").concat(move, "%)")), _ref2;
};
exports.renderThumbStyle = renderThumbStyle;
var ElementPlusError = /*#__PURE__*/function (_Error) {
  (0, _inherits2.default)(ElementPlusError, _Error);
  var _super = (0, _createSuper2.default)(ElementPlusError);
  function ElementPlusError(m) {
    var _this;
    (0, _classCallCheck2.default)(this, ElementPlusError);
    _this = _super.call(this, m);
    _this.name = 'ElementPlusError';
    return _this;
  }
  return (0, _createClass2.default)(ElementPlusError);
}( /*#__PURE__*/(0, _wrapNativeSuper2.default)(Error));
function throwError(scope, m) {
  throw new ElementPlusError("[".concat(scope, "] ").concat(m));
}
function debugWarn(scope, message) {
  if (process.env.NODE_ENV !== 'production') {
    var error = (0, _shared.isString)(scope) ? new ElementPlusError("[".concat(scope, "] ").concat(message)) : scope;
    // eslint-disable-next-line no-console
    console.warn(error);
  }
}
var definePropType = function definePropType(val) {
  return val;
};
exports.definePropType = definePropType;
var isStringNumber = function isStringNumber(val) {
  if (!(0, _shared.isString)(val)) {
    return false;
  }
  return !Number.isNaN(Number(val));
};
exports.isStringNumber = isStringNumber;
var SCOPE = 'utils/dom/style';
function addUnit(value) {
  var defaultUnit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'px';
  if (!value) return '';
  if ((0, _core.isNumber)(value) || isStringNumber(value)) {
    return "".concat(value).concat(defaultUnit);
  } else if ((0, _shared.isString)(value)) {
    return value;
  }
  debugWarn(SCOPE, 'binding value must be a string or number');
}